/* Problem URL: https://codeforces.com/contest/2218/problem/G */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, m;
    cin >> n >> m;

    vi b(n);
    cin >> b;

    if (n == 1) {
        cout << "1\n";
        return;
    }

    const ll mod = 676767677;

    vi pref(m + 1);
    vvi ev(m);

    rep(i, n) {
        pref[b[i] + 1]++;
        ev[b[i]].push_back(i);
    }

    ll ans = 1;
    nrep(i, 1, m + 1) {
        pref[i] += pref[i - 1];
    }

    nrep(i, 1, m) {
        ll r = pref[i];
        ll l = pref[i - 1];
        ll d = r - l;

        repv(j, ev[i]) {
            ll bf = OO;
            if (j > 0) {
                bf = b[j - 1];
            }

            ll af = OO;
            if (j < n - 1) {
                af = b[j + 1];
            }

            if (b[j] <= min(bf, af)) {
                cout << "0\n";
                return;
            }

            if (b[j] > min(bf, af) + 1) {
                (ans *= d) %= mod;
                continue;
            }

            (ans *= r) %= mod;
        }
    }

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
